/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.plugins.impl.grid

import metridoc.plugins.Plugin
import metridoc.plugins.grid.DefaultGridCreator
import metridoc.plugins.grid.Grid
import org.apache.camel.Exchange
import groovy.sql.GroovyRowResult

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 9/8/11
 * Time: 4:25 PM
 * To change this template use File | Settings | File Templates.
 */
@Plugin(category = "grid", name="collection")
class CollectionsGrid extends DefaultGridCreator implements Grid {

    Iterator iterator

    void remove() {
        iterator.remove()
    }

    @Override
    Grid doCreate(Exchange exchange) {
        iterator = exchange.getIn().getBody(Iterator.class)
        return new CollectionsGrid(iterator: iterator)
    }

    LinkedHashSet<String> getColumns() {
        return ["1"] as LinkedHashSet
    }

    int getLine() {
        return 0  //To change body of implemented methods use File | Settings | File Templates.
    }

    @Override
    GroovyRowResult doNext() {
        return [item: iterator.next()]
    }

    @Override
    boolean doHasNext() {
        return iterator.hasNext()
    }
}
